﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Shell;

namespace SolutionSettings {
    class ToolsOptions : DialogPage {
        public bool NeverOfferToUpdateOnClose { get; set; }

        public bool AlwaysUpdateOnClose { get; set; }

        public bool AlwaysUpdateBaselineOnOpen { get; set; }

        private System.Windows.Forms.IWin32Window _Window = null;
        protected override System.Windows.Forms.IWin32Window Window {
            get {
                if (_Window == null) {
                    System.Threading.Interlocked.CompareExchange(ref _Window,
                        base.Window, // TODO: new GeneralOptions()
                        null);
                }
                return _Window;
            }
        }
    }
}
